<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_practice_post".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderPracticePost".
 *
 * Columns in table "provider_practice_post" available as properties of the model,
 * followed by relations of table "provider_practice_post" available as properties of the model.
 *
 * @property integer $id
 * @property integer $practice_id
 * @property string $post_status
 * @property integer $added_by_account_id
 * @property integer $provider_id
 * @property integer $updated_by_account_id
 * @property string $date_added
 * @property string $date_updated
 * @property string $post_offer_url
 * @property string $post_image
 * @property string $post_body
 *
 * @property Practice $practice
 * @property Provider $provider
 */
abstract class BaseProviderPracticePost extends BaseModel
{

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_practice_post';
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderPracticePost|ProviderPracticePosts', $n);
    }

    public static function representingColumn()
    {
        return 'post_status';
    }

    public function rules()
    {
        return array(
            array('practice_id, added_by_account_id', 'required'),
            array('practice_id, added_by_account_id, provider_id, updated_by_account_id', 'numerical', 'integerOnly' => true),
            array('post_status', 'length', 'max' => 9),
            array('post_offer_url, post_image', 'length', 'max' => 255),
            array('date_added, date_updated, post_body', 'safe'),
            array('post_status, provider_id, updated_by_account_id, date_added, date_updated, post_offer_url, post_image, post_body', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, practice_id, post_status, added_by_account_id, provider_id, updated_by_account_id, date_added, date_updated, post_offer_url, post_image, post_body', 'safe', 'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'practice_id' => null,
            'post_status' => Yii::t('app', 'Post Status'),
            'added_by_account_id' => Yii::t('app', 'Added By Account'),
            'provider_id' => null,
            'updated_by_account_id' => Yii::t('app', 'Updated By Account'),
            'date_added' => Yii::t('app', 'Date Added'),
            'date_updated' => Yii::t('app', 'Date Updated'),
            'post_offer_url' => Yii::t('app', 'Post Offer Url'),
            'post_image' => Yii::t('app', 'Post Image'),
            'post_body' => Yii::t('app', 'Post Body'),
            'practice' => null,
            'provider' => null,
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->compare('id', $this->id);
        $criteria->compare('practice_id', $this->practice_id);
        $criteria->compare('post_status', $this->post_status, true);
        $criteria->compare('added_by_account_id', $this->added_by_account_id);
        $criteria->compare('provider_id', $this->provider_id);
        $criteria->compare('updated_by_account_id', $this->updated_by_account_id);
        $criteria->compare('date_added', $this->date_added, true);
        $criteria->compare('date_updated', $this->date_updated, true);
        $criteria->compare('post_offer_url', $this->post_offer_url, true);
        $criteria->compare('post_image', $this->post_image, true);
        $criteria->compare('post_body', $this->post_body, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
        ));
    }

}
